// A dynamic array to store our Hunt instance.
WhosBeingHunted <- [];

// Class Header
class ManHunt {

	// The Constructor.
 	constructor( ... ) {

		// Properties -	we're using 'vargv' to allow the addition of new properties in future.
		PlayerID		=	vargv[ 0 ];
		PlayerName		=	vargv[ 1 ];
		Bounty			=	vargv[ 2 ];
	}

	// Member Functions.
	function Activate()
	{
		if ( ManHunt.IsActive()  ) return "Error - Manhunt is already active";
		else
		{
			// Gather our variables.
			local 
				PlayerID 	=	FindRandPlayer(),
				Player		=	FindPlayer( PlayerID ),
				Bounty		=	rand() % 5000;

			// Push a Manhunt instance into the next array element.
			WhosBeingHunted.push( ManHunt( PlayerID, Player.Name, Bounty ) );

			// Outpiut in-game.
			return ">> ManHunt Activated - Hunting:" + " " + "[ " + Player.Name + " " + "for" + " " + "$" + Bounty + " ]";
		}
	}
	function Deactivate( ... )
	{
		// They left the server, died or commited suicide.
		if ( ( vargv[ 0 ] == "quit" ) || ( vargv[ 0 ] == "died" ) )
		{
			// The player that quit, died or commited suicide.
			local 
				Player		=	vargv[ 1 ];

			// The player that is being hunted.
			local 
				Hunted		=	WhosBeingHunted[ 0 ].PlayerName;

			// Check if it was the player being hunted.
			if ( Player.Name == Hunted )
			{
				// Delete ManHunt instance from array.
				WhosBeingHunted.remove( 0 );

				// Output in-game.
				return ">> ManHunt Deactivated:" + " " + Hunted + " " + vargv[ 0 ];
			}
		}
		// They got killed.
		else if ( vargv[ 0 ] == "killed" )
		{
			// The player that died.
			local 
				Player		=	vargv[ 1 ];

			// The Killer
			local 
				Killer		=	vargv[ 2 ];

			// The player that is being hunted.
			local 
				Hunted		=	WhosBeingHunted[ 0 ].PlayerName,
				Bounty		=	WhosBeingHunted[ 0 ].Bounty;

			// Check if it was the player being hunted.
			if ( Player.Name == Hunted )
			{
				// Delete ManHunt instance from array.
				WhosBeingHunted.remove( 0 );

				// Reward Killer.Name or Killer.ID here...

				// Output in-game.
				return ">> ManHunt Deactivated:" + " " + Killer.Name + " " + "killed" + " " + Hunted + " " + "for" + " " + "$" + Bounty;
			}
		}
	}

	function IsActive()
	{
		// Triadic operator.
		return WhosBeingHunted.len() > 0 ? true : false;
	}


	// Reset Property values
	PlayerID		=	null;
	PlayerName		=	null;
	Bounty			=	null;
}


// Finds a random PlayerID
function FindRandPlayer()
{
	// Our locals.
	local
	    count = 0,
	    buffer = "",
	    param;

	// Iterate all online players
    	for(local i = 0; i < 100; i++)
    	{
		// If we get a player instance.
     		if ( FindPlayer( i ) ) 
		{
			// Make our consecutive string
			buffer = buffer + " " + i;

			// Increase our counter.
			count++;
		}
    	}

	// Split our buffer by space delimiter
	param = split(buffer, " ");

	// Return a random token and convert it to a integer.
	return param[ rand() % count ].tointeger();
}